import { EventPayload } from '@telegram-apps/bridge';
import { AbortablePromise } from 'better-promises';
import { RequestOptionsNoCapture } from '../../../types.js';
/**
 * Requests biometry information.
 * @since Mini Apps v7.2
 * @param options - additional execution options.
 * @throws {FunctionNotAvailableError} The environment is unknown
 * @throws {FunctionNotAvailableError} The SDK is not initialized
 * @throws {FunctionNotAvailableError} The function is not supported
 * @example
 * if (requestBiometry.isAvailable()) {
 *   const biometryState = await requestBiometry();
 * }
 */
export declare const requestBiometry: import('../../wrappers/wrapSafe.js').SafeWrapped<(options?: RequestOptionsNoCapture) => AbortablePromise<EventPayload<"biometry_info_received">>, true, never>;
