import { Computed } from '@telegram-apps/signals';
import { InitData } from '@telegram-apps/types';
/**
 * Complete component state.
 */
export declare const _state: import('@telegram-apps/signals').Signal<InitData | undefined>, state: Computed<InitData | undefined>;
/**
 * @see InitData.auth_date
 */
export declare const authDate: Computed<Date | undefined>;
/**
 * @see InitData.can_send_after
 */
export declare const canSendAfter: Computed<number | undefined>;
/**
 * Date after which it is allowed to call
 * the [answerWebAppQuery](https://core.telegram.org/bots/api#answerwebappquery) method.
 */
export declare const canSendAfterDate: Computed<Date | undefined>;
/**
 * @see InitData.chat
 */
export declare const chat: Computed<import('@telegram-apps/types').Chat | undefined>;
/**
 * @see InitData.chat_type
 */
export declare const chatType: Computed<string | undefined>;
/**
 * @see InitData.chat_instance
 */
export declare const chatInstance: Computed<string | undefined>;
/**
 * @see InitData.hash
 */
export declare const hash: Computed<string | undefined>;
/**
 * @see InitData.query_id
 */
export declare const queryId: Computed<string | undefined>;
/**
 * Raw representation of init data.
 */
export declare const _raw: import('@telegram-apps/signals').Signal<string | undefined>, raw: Computed<string | undefined>;
/**
 * @see InitData.receiver
 */
export declare const receiver: Computed<import('@telegram-apps/types').User | undefined>;
/**
 * Restores the component state.
 */
export declare function restore(): void;
/**
 * @see InitData.start_param
 */
export declare const startParam: Computed<string | undefined>;
/**
 * @see InitData.user
 */
export declare const user: Computed<import('@telegram-apps/types').User | undefined>;
