import { Computed } from '@telegram-apps/signals';
import { State } from './types.js';
export declare const internalState: import('@telegram-apps/signals').Signal<State>;
/**
 * Complete component state.
 */
export declare const state: Computed<Required<State>>;
/**
 * Signal indicating if the Main Button is currently mounted.
 */
export declare const _isMounted: import('@telegram-apps/signals').Signal<boolean>, isMounted: Computed<boolean>;
/**
 * Signal containing the current Main Button background color.
 */
export declare const backgroundColor: Computed<`#${string}`>;
/**
 * Signal indicating if the Main Button has a shining effect.
 */
export declare const hasShineEffect: Computed<boolean>;
/**
 * Signal indicating if the Main Button is currently active and can be clicked.
 */
export declare const isEnabled: Computed<boolean>;
/**
 * Signal indicating if the Main Button displays a loader inside it.
 */
export declare const isLoaderVisible: Computed<boolean>;
/**
 * Signal indicating if the Main Button is currently visible.
 */
export declare const isVisible: Computed<boolean>;
/**
 * Signal containing the Main Button text.
 */
export declare const text: Computed<string>;
/**
 * Signal containing the current Main Button text color.
 */
export declare const textColor: Computed<`#${string}`>;
