import { RequestOptionsNoCapture } from '../../../types.js';
/**
 * Shows a native popup requesting permission for the bot to manage user's emoji status.
 * @param options - additional options.
 * @since Mini Apps v8.0
 * @throws {ConcurrentCallError} Emoji status access request is already in progress
 * @throws {FunctionNotAvailableError} The environment is unknown
 * @throws {FunctionNotAvailableError} The SDK is not initialized
 * @throws {FunctionNotAvailableError} The function is not supported
 * @example
 * if (requestEmojiStatusAccess.isAvailable()) {
 *   const status = await requestEmojiStatusAccess();
 * }
 */
export declare const requestEmojiStatusAccess: import('../../wrappers/wrapSafe.js').SafeWrapped<(options?: RequestOptionsNoCapture) => import('better-promises').AbortablePromise<any>, true, never>;
export declare const requestEmojiStatusAccessPromise: import('@telegram-apps/signals').Computed<import('better-promises').AbortablePromise<any> | undefined>, isRequestingEmojiStatusAccess: import('@telegram-apps/signals').Computed<boolean>;
export declare const requestEmojiStatusAccessError: import('@telegram-apps/signals').Computed<Error | undefined>;
