import { AbortablePromise } from 'better-promises';
import { InvokeCustomMethodOptions } from '@telegram-apps/bridge';
/**
 * @returns Current server time.
 * @param options - execution options.
 * @since Mini Apps v6.9
 * @throws {FunctionNotAvailableError} The environment is unknown
 * @throws {FunctionNotAvailableError} The SDK is not initialized
 * @throws {FunctionNotAvailableError} The function is not supported
 * @example
 * if (getCurrentTime.isAvailable()) {
 *   const time = await getCurrentTime();
 * }
 */
export declare const getCurrentTime: import('../../wrappers/wrapSafe.js').SafeWrapped<(options?: InvokeCustomMethodOptions) => AbortablePromise<Date>, true, never>;
