export interface AndroidDeviceData {
    appVersion?: string;
    manufacturer?: string;
    model?: string;
    androidVersion?: string;
    sdkVersion?: number;
    performanceClass?: 'LOW' | 'AVERAGE' | 'HIGH' | string;
}
/**
 * Retrieves Android device data from the specified User Agent.
 * @see https://core.telegram.org/bots/webapps#additional-data-in-user-agent
 * @param userAgent - user agent.
 */
export declare function retrieveAndroidDeviceDataFrom(userAgent: string): AndroidDeviceData;
