/**
 * Sends data to the bot.
 *
 * When this method called, a service message sent to the bot containing the data of the length
 * up to 4096 bytes, and the Mini App closed.
 *
 * See the field `web_app_data` in the class [Message](https://core.telegram.org/bots/api#message).
 *
 * This method is only available for Mini Apps launched via a Keyboard button.
 * @param data - data to send to bot.
 * @throws {FunctionNotAvailableError} The function is not supported
 * @throws {FunctionNotAvailableError} The environment is unknown
 * @throws {InvalidArgumentsError} Maximum size of data to send is 4096 bytes
 * @throws {InvalidArgumentsError} Attempted to send empty data
 * @example
 * if (sendData.isAvailable()) {
 *   sendData('Here comes my data');
 * }
 */
export declare const sendData: import('../../wrappers/wrapSafe.js').SafeWrapped<(data: string) => void, true, never>;
