import { AbortablePromise } from 'better-promises';
import { AsyncOptions } from '../../../types.js';
/**
 * Opens a dialog allowing the user to share a message provided by the bot.
 * @since Mini Apps v8.0
 * @throws {FunctionNotAvailableError} The function is not supported
 * @throws {FunctionNotAvailableError} The environment is unknown
 * @throws {FunctionNotAvailableError} The SDK is not initialized
 * @throws {ShareMessageError} Message sharing failed.
 * @example
 * if (shareMessage.isAvailable()) {
 *   await shareMessage('bbhjSYgvck23');
 * }
 */
export declare const shareMessage: import('../../wrappers/wrapSafe.js').SafeWrapped<(id: string, options?: AsyncOptions) => AbortablePromise<void>, true, never>;
